#ifndef RT_ASSET_DEPENDENCIES_H
#define RT_ASSET_DEPENDENCIES_H

#include "assets.h"

#ifdef RT_DEFINE_DEPENDENCY_FILE_STRUCTURES

#include "xxhash/xxhash.h"

#pragma pack(push, 1)
typedef struct {
    uint64_t data_size;
    uint32_t num_lists;
} rt_dependency_file_header;

typedef struct {
    rt_uid uid;
    uint32_t num_entries;
    XXH64_canonical_t checksum;
} rt_dependency_file_list_header;

#pragma pack(pop)

#endif

typedef struct {
    const rt_uid *dependencies;
    uint32_t count;
} rt_asset_dependency_list;

RT_DLLEXPORT rt_asset_dependency_list rtGetAssetDependencies(rt_uid asset);

#endif
