#ifndef RT_SHADER_COMPILER_H
#define RT_SHADER_COMPILER_H

#include "mem_arena.h"
#include "runtime.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
    RT_SHADER_TYPE_INVALID,
    RT_SHADER_TYPE_VULKAN,

    RT_SHADER_TYPE_COUNT,
} rt_shader_type;

typedef enum {
    RT_SHADER_STAGE_VERTEX,
    RT_SHADER_STAGE_FRAGMENT,
    RT_SHADER_STAGE_COMPUTE,
} rt_shader_stage;

typedef enum {
    RT_SHADER_OPTIMIZATION_NONE,
    RT_SHADER_OPTIMIZATION_SPEED,
    RT_SHADER_OPTIMIZATION_SIZE,
} rt_shader_optimization_level;

typedef struct {
    void *bytes;
    size_t len;
} rt_shader_bytecode;

rt_shader_bytecode CompileShader(rt_shader_type type,
                                 rt_shader_stage stage,
                                 rt_shader_optimization_level optimization,
                                 rt_text_span code,
                                 const char *input_file,
                                 rt_arena *arena);

#ifdef __cplusplus
}
#endif

#endif
