#ifndef RT_ASSETC_UTILS_H
#define RT_ASSETC_UTILS_H

#include <stdint.h>

#include "runtime/file_tab.h"

size_t rtGetFileSize(const char *path);

void rtSetWorkingDirectory(const char *path);

uint64_t rtGetCurrentTimestamp(void);

uint64_t rtGetFileModificationTimestamp(rt_file_id fid);

typedef enum {
    RT_DIR_ELEMENT_TYPE_FILE,
    RT_DIR_ELEMENT_TYPE_DIRECTORY,
} rtIterateDirElementType;

typedef rt_result rt_iterate_directory_cb_func(const char *name, rtIterateDirElementType type, void *user);

rt_result rtIterateDirectory(const char *path, void *user, rt_iterate_directory_cb_func iterate_cb);

rt_result rtCreateDirectory(const char *path);

#endif
